package org.rcisoft.business.cmsbanner.dao;


import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.cmsbanner.entity.CmsBanner;
import org.rcisoft.business.cmsbanner.entity.CmsBannerDTO;
import org.rcisoft.core.mapper.CyBaseMapper;
import org.rcisoft.core.model.CyPageInfo;

import java.util.List;


/**
 * Created with cy on 2024年3月30日 下午1:51:15.
 */

public interface CmsBannerRepository extends CyBaseMapper<CmsBanner> {


    List<CmsBanner> queryCmsBanners(@Param("entity") CmsBanner cmsBanner);

    /**
     * 分页查询 cmsBanner
     */
    IPage<CmsBanner> queryCmsBannersPaged(CyPageInfo cyPageInfo, @Param("entity") CmsBanner cmsBanner);


    CmsBanner selectByIdWithUrl(String id);

    //超级管理员banner分页查询
    IPage<CmsBanner> superAdminPaginationCheck(CyPageInfo<CmsBanner> paginationUtility, @Param("entity") CmsBannerDTO cmsBanner);

    //商家管理员banner分页查询
    IPage<CmsBanner> merchantAdminPaginationCheck(CyPageInfo<CmsBanner> paginationUtility, @Param("entity") CmsBannerDTO cmsBanner);

    //代言人banner分页查询  而且只能看自己的banner并状态为1 且不能删除
    IPage<CmsBanner> spokespersonPagination(CyPageInfo<CmsBanner> paginationUtility, @Param("entity") CmsBannerDTO cmsBanner);

    //游客banner分页查询
    IPage<CmsBanner> visitorPagination(CyPageInfo<CmsBanner> paginationUtility, CmsBannerDTO cmsBanner);

}

