package org.rcisoft.business.cmsbannerunit.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.rcisoft.business.cmsbannerunit.entity.CmsBannerUnit;
import org.rcisoft.business.sysunit.entity.SysUnit;
import org.rcisoft.core.model.CyPageInfo;
import org.rcisoft.core.model.CyPersistModel;

import java.util.List;

/**
 * Created by cy on 2024年6月7日 下午2:29:37.
 */
public interface CmsBannerUnitService {

    /**
     * 保存 banner与商家中间表
     *
     * @param cmsBannerUnit
     * @return
     */
    CyPersistModel persist(CmsBannerUnit cmsBannerUnit);

    /**
     * 删除 banner与商家中间表
     *
     * @param cmsBannerUnit
     * @return
     */
    CyPersistModel remove(CmsBannerUnit cmsBannerUnit);

    /**
     * 修改 banner与商家中间表
     *
     * @param cmsBannerUnit
     * @return
     */
    CyPersistModel merge(CmsBannerUnit cmsBannerUnit);

    /**
     * 根据id查询 banner与商家中间表
     *
     * @param id
     * @return
     */
    CmsBannerUnit findById(int id);

    /**
     * 分页查询 banner与商家中间表
     *
     * @param cmsBannerUnit
     * @return
     */
    IPage<CmsBannerUnit> findAllByPagination(CyPageInfo<CmsBannerUnit> paginationUtility,
                                             CmsBannerUnit cmsBannerUnit);


    /**
     * 查询list banner与商家中间表
     *
     * @param cmsBannerUnit
     * @return
     */
    List<CmsBannerUnit> findAll(CmsBannerUnit cmsBannerUnit);


    /**
     * 导出banner与商家中间表
     *
     * @return
     */
    List<CmsBannerUnit> export(CmsBannerUnit cmsBannerUnit);

    void deleteTheUserByMerchantId(SysUnit sysUnit);
}
