package org.rcisoft.business.cmsnews.entity;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.baomidou.mybatisplus.annotation.TableField;
import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;

import org.rcisoft.core.entity.CyIdIncreEntity;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
* Created with cy on 2024年6月3日 下午3:35:01.
*/
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("cms_news")
public class CmsNews  extends CyIdIncreEntity<CmsNews> {


     /**
     * @desc 发布日期
     * @column release_date
     * @default
     */
     @JsonFormat(
     pattern = "yyyy-MM-dd"
     )
     @Excel(name = "发布日期", orderNum = "0", width = 20, format = "yyyy-MM-dd")
     @DateTimeFormat(pattern = "yyyy-MM-dd")
     private Date releaseDate;

     /**
     * @desc 板块
     * @column plate
     * @default
     */
     @Excel(name = "板块", orderNum = "1", width = 20)
     private String plate;

     /**
     * @desc 标题
     * @column title
     * @default
     */
     @Excel(name = "标题", orderNum = "2", width = 20)
     private String title;

     /**
     * @desc 内容
     * @column details
     * @default
     */
     @Excel(name = "内容", orderNum = "3", width = 20)
     private String details;

     /**
     * @desc 排序
     * @column weight
     * @default
     */
     @Excel(name = "排序", orderNum = "4", width = 20)
     private Integer weight;

     /**
     * @desc 封面
     * @column picture_id
     * @default
     */
     @Excel(name = "封面", orderNum = "5", width = 20)
     private String pictureId;

     /**
     * @desc 是否为头条
     * @column is_fornt_page
     * @default
     */
     @Excel(name = "是否为头条", orderNum = "6", width = 20)
     private Integer isForntPage;

     /**
     * @desc 是否为推荐
     * @column is_recommended
     * @default
     */
     @Excel(name = "是否为推荐", orderNum = "7", width = 20)
     private Integer isRecommended;

     /**
     * @desc 是否为置顶
     * @column is_top
     * @default
     */
     @Excel(name = "是否为置顶", orderNum = "8", width = 20)
     private Integer isTop;

     /**
     * @desc 文章来源(0:爬虫 1:自建)
     * @column news_type
     * @default
     */
     @Excel(name = "文章来源(0:爬虫 1:自建)", orderNum = "9", width = 20)
     private String newsType;

     /**
     * @desc 房客id
     * @column tenant
     * @default
     */
     @Excel(name = "房客id", orderNum = "10", width = 20)
     private Integer tenant;

     /**
     * 开始时间
     */
     @JsonIgnore
     @TableField(exist = false)
     private String beginTime;

     /**
     * 结束时间
     */
     @JsonIgnore
     @TableField(exist = false)
     private String endTime;

     /**
      * 封面路径
      */
     private transient String path;


     /**
      * 阅读量
      */
     private transient Integer readNum;

     /**
      * 所属商家
      */
     private transient String unitId;

     /**
      * 当前登录人员id
      */
     private transient Integer userId;
     /**
      * 首页 / (分类我的)
      * */
     private transient String source;

}

