package org.rcisoft.business.cmsnews.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.rcisoft.business.cmsnews.dto.MiniCmsNewsOrVideo;
import org.rcisoft.business.cmsnews.entity.CmsNews;
import org.rcisoft.business.cmsvideo.entity.CmsVideo;
import org.rcisoft.core.model.CyPageInfo;
import org.rcisoft.core.model.CyPersistModel;

import java.util.HashMap;
import java.util.List;

/**
 * Created by cy on 2024年6月3日 下午3:35:01.
 */
public interface CmsNewsService {

    /**
     * 保存 文章表
     *
     * @param cmsNews
     * @return
     */
    CyPersistModel persist(CmsNews cmsNews);

    /**
     * 删除 文章表
     *
     * @param cmsNews
     * @return
     */
    CyPersistModel remove(CmsNews cmsNews);

    /**
     * 逻辑删除 文章表
     *
     * @param cmsNews
     * @return
     */
    CyPersistModel removeLogical(CmsNews cmsNews);

    /**
     * 修改 文章表
     *
     * @param cmsNews
     * @return
     */
    CyPersistModel merge(CmsNews cmsNews);

    /**
     * 根据id查询 文章表
     *
     * @param id
     * @return
     */
    CmsNews findById(int id);

    /**
     * 分页查询 文章表
     *
     * @param cmsNews
     * @return
     */
    IPage<CmsNews> findAllByPagination(CyPageInfo<CmsNews> paginationUtility,
                                       CmsNews cmsNews);


    /**
     * 查询list 文章表
     *
     * @param cmsNews
     * @return
     */
    List<CmsNews> findAll(CmsNews cmsNews);


    /**
     * 导出文章表
     *
     * @return
     */
    List<CmsNews> export(CmsNews cmsNews);


    IPage<CmsNews> listMiniProgram(CyPageInfo<CmsNews> paginationUtility, CmsNews cmsNews);

    /**
     * 分类查询当前用户可看的文章
     *
     * @param paginationUtility
     * @param cmsNews
     */
    HashMap<String, List<MiniCmsNewsOrVideo>> listByNewsAndVideo(CyPageInfo<CmsNews> paginationUtility, CmsNews cmsNews);

    IPage<CmsNews> listByClassification(CyPageInfo<CmsNews> paginationUtility, CmsNews cmsNews);

    Integer selectDictionaryControl(String name, String hōtoriNum);

    String getNewsByTitleByTitle(String title);

    IPage<CmsVideo> listByTopVideo(CyPageInfo<CmsNews> paginationUtility, CmsVideo cmsVideo);
}
