package org.rcisoft.business.cmstask.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.rcisoft.business.cmstask.entity.CmsTask;
import org.rcisoft.core.model.CyPageInfo;
import org.rcisoft.core.model.CyPersistModel;

import java.util.List;

/**
 * Created by cy on 2024年6月11日 下午5:32:32.
 */
public interface CmsTaskService {

    /**
     * 保存 任务表
     *
     * @param cmsTask
     * @return
     */
    CyPersistModel persist(CmsTask cmsTask);

    /**
     * 删除 任务表
     *
     * @param cmsTask
     * @return
     */
    CyPersistModel remove(CmsTask cmsTask);

    /**
     * 逻辑删除 任务表
     *
     * @param cmsTask
     * @return
     */
    CyPersistModel removeLogical(CmsTask cmsTask);

    /**
     * 修改 任务表
     *
     * @param cmsTask
     * @return
     */
    CyPersistModel merge(CmsTask cmsTask);

    /**
     * 根据id查询 任务表
     *
     * @param id
     * @return
     */
    CmsTask findById(String id);

    /**
     * 分页查询 任务表
     *
     * @param cmsTask
     * @return
     */
    IPage<CmsTask> findAllByPagination(CyPageInfo<CmsTask> paginationUtility,
                                       CmsTask cmsTask);


    /**
     * 查询list 任务表
     *
     * @param cmsTask
     * @return
     */
    List<CmsTask> findAll(CmsTask cmsTask);


    /**
     * 导出任务表
     *
     * @return
     */
    List<CmsTask> export(CmsTask cmsTask);

    CmsTask add(String name);
}
