package org.rcisoft.business.cmsunitnewvideo.controller;


/*固定导入*/
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import oracle.ucp.proxy.annotation.Post;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.rcisoft.core.util.CyEpExcelUtil;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.controller.CyPaginationController;
import org.rcisoft.core.util.CyUserUtil;
import org.rcisoft.core.model.CyGridModel;
import org.rcisoft.core.exception.CyServiceException;
import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;


import org.rcisoft.business.cmsunitnewvideo.entity.CmsUnitNewVideo;
import org.rcisoft.business.cmsunitnewvideo.service.CmsUnitNewVideoService;

import java.util.List;

/**
* Created by cy on 2024年6月6日 上午10:17:38.
*/
@RestController
@RequestMapping("/cmsunitnewvideo")
public class CmsUnitNewVideoController extends CyPaginationController<CmsUnitNewVideo> {


    @Autowired
    private CmsUnitNewVideoService cmsUnitNewVideoServiceImpl;

    //@PreAuthorize("@cyPerm.hasPerm('sys:unitNewVideo:add')")
    @CyOpeLogAnno(title = "system-文章视频分配中间表管理-新增文章视频分配中间表", businessType = CyLogTypeEnum.INSERT)
    @ApiOperation(value="添加文章视频分配中间表", notes="添加文章视频分配中间表")
    @PostMapping(value = "/addOrUpdate")
    public CyResult addOrUpdate(@Valid CmsUnitNewVideo cmsUnitNewVideo, BindingResult bindingResult) {
        CyPersistModel data = cmsUnitNewVideoServiceImpl.addOrUpdate(cmsUnitNewVideo);
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        cmsUnitNewVideo);
    }

    /**
     * 根据商家id,类型  查询出 商家绑定所有文章或视频信息
     * */
    @CyOpeLogAnno(title = "system-文章视频分配中间表管理-查询文章视频分配中间表", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value="查询文章视频分配中间表", notes="查询文章视频分配中间表")
    @GetMapping(value = "/listAllByUnitIdType")
    public CyResult listAllByUnitIdType(CmsUnitNewVideo cmsUnitNewVideo) {
        List<CmsUnitNewVideo> data = cmsUnitNewVideoServiceImpl.listAllByUnitIdType(cmsUnitNewVideo);
        return CyResultGenUtil.builder(new CyPersistModel(1),
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
                data);
    }


}
