package org.rcisoft.business.cmsunitnewvideo.entity;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import org.rcisoft.core.entity.CyIdIncreNotDataEntity;

/**
 * Created with cy on 2024年6月6日 上午10:17:38.
 */
@Data
@TableName("cms_unit_new_video")
public class CmsUnitNewVideo extends CyIdIncreNotDataEntity<CmsUnitNewVideo> {


    /**
     * @desc 文章/视频id
     * @column news_video_id
     * @default
     */
    @Excel(name = "文章/视频id", orderNum = "0", width = 20)
    private Integer newsVideoId;

    /**
     * @desc 商家id
     * @column unit_id
     * @default
     */
    @Excel(name = "商家id", orderNum = "1", width = 20)
    private String unitId;

    /**
     * @desc 类型(0 : 文章 1 : 视频)
     * @column type
     * @default
     */
    @Excel(name = "类型(0:文章 1:视频)", orderNum = "2", width = 20)
    private String type;

    /**
     * 文章/视频标题
     */
    @Excel(name = "文章/视频标题", orderNum = "3", width = 20)
    @TableField(exist = false)
    private String title;


}

