package org.rcisoft.business.cmsvideo.entity;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.baomidou.mybatisplus.annotation.TableField;
import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;

import org.rcisoft.core.entity.CyIdIncreEntity;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
* Created with cy on 2024年6月3日 下午3:35:01.
*/
@Data
@TableName("cms_video")
public class CmsVideo  extends CyIdIncreEntity<CmsVideo> {


     /**
     * @desc 视频标题
     * @column video_title
     * @default
     */
     @Excel(name = "视频标题", orderNum = "0", width = 20)
     private String videoTitle;

     /**
     * @desc 首页显示(0:不显示; 1: 显示)
     * @column home_display
     * @default
     */
     @Excel(name = "首页显示(0:不显示; 1: 显示)", orderNum = "1", width = 20)
     private String homeDisplay;

     /**
     * @desc 默认封面图片url
     * @column default_url
     * @default
     */
     @Excel(name = "默认封面图片url", orderNum = "2", width = 20)
     private String defaultUrl;

     /**
     * @desc 视频urlid
     * @column video_url_id
     * @default
     */
     @Excel(name = "视频urlid", orderNum = "3", width = 20)
     private String videoUrlId;
     /**
      * 视频名称
      * */
     @TableField(exist = false)
     private String videoName;
     /**
     * @desc 发布时间
     * @column release_time
     * @default
     */
     @JsonFormat(
     pattern = "yyyy-MM-dd"
     )
     @Excel(name = "发布时间", orderNum = "4", width = 20, format = "yyyy-MM-dd")
     @DateTimeFormat(pattern = "yyyy-MM-dd")
     private Date releaseTime;

     /**
     * @desc 来源
     * @column source
     * @default
     */
     @Excel(name = "来源", orderNum = "5", width = 20)
     private String videoType;

     /**
     * @desc 房客id
     * @column tenant
     * @default
     */
     @Excel(name = "房客id", orderNum = "6", width = 20)
     private Integer tenant;

     /**
     * 开始时间
     */
     @JsonIgnore
     @TableField(exist = false)
     private String beginTime;

     /**
     * 结束时间
     */
     @JsonIgnore
     @TableField(exist = false)
     private String endTime;

     /**
      * 封面路径
      */
     private transient String path;

     /**
      * 阅读量
      */
     private transient Integer readNum;

     /**
      * 所属商家
      */
     private transient String unitId;

     /**
      * 用户id
      */
     private transient Integer userId;

}

