package org.rcisoft.business.cmsvideo.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.rcisoft.business.cmsnews.entity.CmsNews;
import org.rcisoft.business.cmsvideo.entity.CmsVideo;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.aop.CyPageUtilAsp;
import org.rcisoft.core.model.CyPageInfo;

import java.util.List;

/**
 * Created by cy on 2024年6月3日 下午3:35:01.
 */
public interface CmsVideoService {

    /**
    * 保存 视频表
    * @param cmsVideo
    * @return
    */
    CyPersistModel persist(CmsVideo cmsVideo);

    /**
    * 删除 视频表
    * @param cmsVideo
    * @return
    */
    CyPersistModel remove(CmsVideo cmsVideo);

    /**
    * 逻辑删除 视频表
    * @param cmsVideo
    * @return
    */
    CyPersistModel removeLogical(CmsVideo cmsVideo);

    /**
    * 修改 视频表
    * @param cmsVideo
    * @return
    */
    CyPersistModel merge(CmsVideo cmsVideo);

    /**
    * 根据id查询 视频表
    * @param id
    * @return
    */
    CmsVideo findById(int id);

    /**
    * 分页查询 视频表
    * @param cmsVideo
    * @return
    */
    IPage<CmsVideo> findAllByPagination(CyPageInfo<CmsVideo> paginationUtility,
              CmsVideo cmsVideo);


    /**
    * 查询list 视频表
    * @param cmsVideo
    * @return
    */
    List<CmsVideo> findAll(CmsVideo cmsVideo);


    /**
    * 导出视频表
    * @return
    */
    List<CmsVideo> export(CmsVideo cmsVideo);


    /**
     * 查询视频url地址
     * @param cmsVideo
     * @return
     */
    CmsVideo getVideoUrl(CmsVideo cmsVideo);

    IPage<CmsVideo> listByClassification(CyPageInfo<CmsVideo> paginationUtility, CmsVideo cmsVideo);
}
