package org.rcisoft.business.sysunit.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.rcisoft.business.cmspriceclick.entity.CmsPriceClick;
import org.rcisoft.business.sysunit.dto.StatisticsDto;
import org.rcisoft.business.sysunit.entity.SysUnit;
import org.rcisoft.core.model.CyPageInfo;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.sys.rbac.user.entity.SysUserRbac;

import java.util.List;
import java.util.Map;

/**
 * Created by cy on 2024年6月3日 下午3:35:01.
 */
public interface SysUnitService {

    /**
     * 保存 单位管理
     *
     * @param sysUnit
     * @return
     */
    CyPersistModel persist(SysUnit sysUnit);

    /**
     * 删除 单位管理
     *
     * @param sysUnit
     * @return
     */
    CyPersistModel remove(SysUnit sysUnit);

    /**
     * 逻辑删除 单位管理
     *
     * @param sysUnit
     * @return
     */
    CyPersistModel removeLogical(SysUnit sysUnit);

    /**
     * 修改 单位管理
     *
     * @param sysUnit
     * @return
     */
    CyPersistModel merge(SysUnit sysUnit);

    /**
     * 根据id查询 单位管理
     *
     * @param id
     * @return
     */
    SysUnit findById(int id);

    /**
     * 分页查询 单位管理
     *
     * @param sysUnit
     * @return
     */
    IPage<SysUnit> findAllByPagination(CyPageInfo<SysUnit> paginationUtility,
                                       SysUnit sysUnit);


    /**
     * 查询list 单位管理
     *
     * @param sysUnit
     * @return
     */
    List<SysUnit> findAll(SysUnit sysUnit);


    /**
     * 导出单位管理
     *
     * @return
     */
    List<SysUnit> export(SysUnit sysUnit);

    List<SysUserRbac> listAllUser(SysUserRbac sysUserRbac);

    List<SysUserRbac> queryUnitAdmin(SysUserRbac sysUserRbac);

    SysUnit statistics(SysUnit sysUnit);

    List<SysUnit> findUnitByUnit();

    List<StatisticsDto> statisticsByTypeBarChart(SysUnit sysUnit);

    void deleteTheUserByMerchantId(SysUnit sysUnit);

    Map<Integer, List<StatisticsDto>> statisticsByTypePieChart(SysUnit sysUnit);

    List<StatisticsDto> statisticsByType(SysUnit dto);

    List<CmsPriceClick> aListOfPromotionAmounts(SysUnit sysUnit);
}
