package org.rcisoft.business.sysuser.dao;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.sysuser.entity.AddSysUser;
import org.rcisoft.business.sysuser.entity.SysUser;
import org.rcisoft.business.sysuser.entity.SysUserUnit;
import org.rcisoft.core.mapper.CyBaseMapper;
import org.rcisoft.core.model.CyPageInfo;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * Created with cy on 2024年6月4日 上午10:19:34.
 */

public interface AdminSysUserRepository extends CyBaseMapper<SysUser> {




    List<SysUser> querySysUsers(@Param("entity") SysUser sysUser);

    /**
     * 分页查询 sysUser
     */
    IPage<SysUser> querySysUsersPaged(CyPageInfo cyPageInfo, @Param("entity") SysUser sysUser);

    SysUser checkAddRepeat(@Param("entity") AddSysUser userToAdd);

    /**
     * 查询一个商家的所有信息
     *
     * @param sysUser
     * @return
     */
    SysUser selectAllUserInfo(@Param("entity") SysUser sysUser);

    /**
     * 查询当前用户的商家信息
     *
     * @param businessId
     * @return
     */
    List<Integer> selectByUnitIds(Integer businessId);

    SysUser checkAddUpload(@Param("entity") SysUser user);

    /**
     * 查询当前用户的商家信息
     *
     * @param businessId
     * @param deptIdPrepare
     * @return
     */
    List<SysUserUnit> selectByUnitIdAndUserId(@Param("userId") Integer businessId, @Param("unitId") BigInteger deptIdPrepare);

    ArrayList<SysUser> selectIdcardBid();
}

