package org.rcisoft.business.sysuser.emuns;

import org.rcisoft.core.result.CyResExcEnum;

public enum AdminUserInfoExceptionEnums implements CyResExcEnum {

    PHONE_NOT_EXISTS(4007, "当前手机号不存在"),

    PHONE_NOT_MATCH(4007, "手机号和当前登录人手机号不匹配"),

    PHONE_CODE_ERROR(4007, "验证码错误"),

    PHONE_EXISTS(4007, "该手机号已被其他用户使用"),

    ID_NUMBER_EXISTS(4007, "该身份证号已被其他用户使用"),

    EMAIL_EXISTS(4007, "该邮箱已被其他用户使用"),

    BANK_CARD_EXISTS(4007, "该银行卡已被其他用户使用"),

    USERNAME_EXISTS(4007, "该登录名已被其他用户使用"),

    ERROR_LOG_NOT_EXISTS(200, "无当前月份异常日志信息"),

    OPER_LOG_NOT_EXISTS(4007, "无当前月份操作日志信息"),

    EXCEL_NULL(503, "上传文件为空"),

    LOGIN_INFO_NOT_EXISTS(200, "无当前年份登录日志信息"),

    ERROR_LOG_NOT_EXISTS_EXPORT(4007, "无当前年份异常日志信息"),

    OPER_LOG_NOT_EXISTS_EXPORT(4007, "无当前月份操作日志信息"),

    LOGIN_INFO_NOT_EXISTS_EXPORT(4007, "无当前月份登录日志信息"),

    /**
     * 当前用户无权登录
     */
    USER_NOT_LOGINPERMISSIOR(4007, "当前用户无权登录"),

    USERNAME_NOT_EXISTS(4007, "当前用户不存在"),
    PHONE_LENGTH_ERROR(4007, "当前手机号错误或不能为空"),
    ID_LENGTH_ERROR(4007, "当前身份证号错误或不能为空"),
    BANK_LENGTH_ERROR(4007, "当前银行卡号错误或不能为空"),
    CLICK_THROUGH_RATE_ERROR(4007, "当前推广次数错误或不能为空"),
    PRICE_ERROR(4007, "当前价格错误或不能为空"),
    USER_NAME_LENGTH_ERROR(4007, "当前用户名称错误");

    private Integer code;
    private String message;

    private AdminUserInfoExceptionEnums() {
    }

    private AdminUserInfoExceptionEnums(Integer code, String message) {
        this.code = code;
        this.message = message;
    }

    public Integer getCode() {
        return this.code;
    }

    public String getMessage() {
        return this.message;
    }
}
