package org.rcisoft.business.sysuser.entity;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Data;
import org.rcisoft.core.entity.CyIdIncreEntity;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigInteger;
import java.util.Date;

/**
 * Created with cy on 2024年6月4日 上午10:19:34.
 */
@Data
@TableName("sys_user")
public class SysUser extends CyIdIncreEntity<SysUser> {


    /**
     * @desc 登录名
     * @column username
     * @default
     */
//     @Excel(name = "登录名", orderNum = "0", width = 20)
    private String username;

    /**
     * @desc 用户昵称
     * @column nick_name
     * @default
     */
//     @Excel(name = "用户昵称", orderNum = "1", width = 20)
    private String nickName;

    /**
     * @desc 用户类型（0系统用户 1普通用户）
     * @column user_type
     * @default
     */
//     @Excel(name = "用户类型（0系统用户 1普通用户）", orderNum = "2", width = 20)
    private String userType;

    /**
     * @desc 用户姓名
     * @column name
     * @default
     */
    @Excel(name = "姓名", orderNum = "3", width = 30)
    private String name;

    /**
     * @desc 用户邮箱
     * @column email
     * @default
     */
//     @Excel(name = "用户邮箱", orderNum = "4", width = 20)
    private String email;

    /**
     * @desc 手机号码
     * @column phone
     * @default
     */
    @Excel(name = "手机号", orderNum = "5", width = 30)
    private String phone;

    /**
     * @desc 用户性别（0男 1女 2未知）
     * @column sex
     * @default
     */
//     @Excel(name = "用户性别（0男 1女 2未知）", orderNum = "6", width = 20)
    private String sex;

    /**
     * @desc 密码
     * @column password
     * @default
     */
//     @Excel(name = "密码", orderNum = "7", width = 20)
    private String password;

    /**
     * @desc 身份证号
     * @column id_number
     * @default
     */
    @Excel(name = "身份证号", orderNum = "8", width = 30)
    private String idNumber;

    /**
     * @desc 头像地址
     * @column avatar
     * @default
     */
//     @Excel(name = "头像地址", orderNum = "9", width = 20)
    private String avatar;

    /**
     * @desc 最后登录ip
     * @column login_ip
     * @default
     */
//     @Excel(name = "最后登录ip", orderNum = "10", width = 20)
    private String loginIp;

    /**
     * @desc 最后登录时间
     * @column login_date
     * @default
     */
    @JsonFormat(
            pattern = "yyyy-MM-dd"
    )
//     @Excel(name = "最后登录时间", orderNum = "11", width = 20, format = "yyyy-MM-dd")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date loginDate;

    /**
     * @desc 所属部门id
     * @column dept_id
     * @default
     */
//     @Excel(name = "所属部门id", orderNum = "12", width = 20)
    private BigInteger deptId;


    /**
     * @desc 身份（1:管理员2:单位用户，3:个人用户）
     * @column identity
     * @default
     */
//     @Excel(name = "身份（1:管理员 2:单位用户）", orderNum = "13", width = 20)
    private String identity;

    /**
     * @desc 微信id
     * @column wx_openid
     * @default
     */
//     @Excel(name = "微信id", orderNum = "14", width = 20)
    private String wxOpenid;

    /**
     * @desc wx地址
     * @column wx_address
     * @default
     */
//     @Excel(name = "wx地址", orderNum = "15", width = 20)
    private String wxAddress;

    /**
     * @desc wx头像
     * @column wx_head
     * @default
     */
//     @Excel(name = "wx头像", orderNum = "16", width = 20)
    private String wxHead;

    /**
     * @desc wx性别
     * @column wx_sex
     * @default
     */
//     @Excel(name = "wx性别", orderNum = "17", width = 20)
    private String wxSex;

    /**
     * @desc wx昵称
     * @column wx_nick_name
     * @default
     */
//     @Excel(name = "wx昵称", orderNum = "18", width = 20)
    private String wxNickName;

    /**
     * @desc 地址
     * @column address
     * @default
     */
//     @Excel(name = "地址", orderNum = "19", width = 20)
    private String address;

    /**
     * @desc 职位
     * @column position
     * @default
     */
//     @Excel(name = "职位", orderNum = "20", width = 20)
    private String position;

    /**
     * 开始时间
     */
    @JsonIgnore
    @TableField(exist = false)
    private String beginTime;

    /**
     * 结束时间
     */
    @JsonIgnore
    @TableField(exist = false)
    private String endTime;

    /**
     * 银行卡号
     */
    @Excel(name = "银行卡号", orderNum = "20", width = 30)
    private transient String bankCardNum;

    /**
     * 商家名称
     */
    @TableField(exist = false)
//     @Excel(name = "商家名称", orderNum = "21", width = 30)
    private transient String deptName;

    /**
     * 商家id 多条数据 备选赋值
     */
    private transient BigInteger deptIdPrepare;
    /**
     * 商家ids
     */
    private transient String deptIdPrepares;
    /**
     * 商家id
     * */
    private transient String unitId;

}

