package org.rcisoft.business.sysuser.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.rcisoft.business.sysuser.entity.AddSysUser;
import org.rcisoft.business.sysuser.entity.SysUser;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.model.CyPageInfo;
import org.rcisoft.sys.rbac.user.entity.SysUserRbac;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * Created by cy on 2024年6月4日 上午10:19:34.
 */
public interface AdminSysUserService {

    /**
    * 保存 用户表
    * @param sysUser
    * @return
    */
    CyPersistModel persist(AddSysUser sysUser);

    /**
    * 删除 用户表
    * @param sysUser
    * @return
    */
    CyPersistModel remove(SysUser sysUser);

    /**
    * 逻辑删除 用户表
    * @param sysUser
    * @return
    */
    CyPersistModel removeLogical(SysUser sysUser);

    /**
    * 修改 用户表
    * @param sysUser
    * @return
    */
    CyPersistModel merge(SysUser sysUser);

    /**
    * 根据id查询 用户表
    * @param id
    * @return
    */
    SysUser findById(int id);

    /**
    * 分页查询 用户表
    * @param sysUser
    * @return
    */
    IPage<SysUser> findAllByPagination(CyPageInfo<SysUser> paginationUtility,
              SysUser sysUser);


    /**
    * 查询list 用户表
    * @param sysUser
    * @return
    */
    List<SysUser> findAll(SysUser sysUser);


    /**
    * 导出用户表
    * @return
    */
    List<SysUser> export(SysUser sysUser);

    /**
     * 导入代言人信息
     * @param file
     * @return
     */
    String importData(MultipartFile file,Integer deptId);

}
