package org.rcisoft.core.util;

import org.apache.commons.codec.binary.Base64;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;

import javax.crypto.Cipher;
import java.security.KeyFactory;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;

/**
 * @author air
 */
@Component
public class RSAUtil {



    /**
     * 私钥
     */
    public static final String PRIVATE_KEY = "MIIEvQIBADANBgkqhkiG9w0BAQEFAASCBKcwggSjAgEAAoIBAQDOv5+1+x4nG" +
            "XdcO59HCqt9atsBZa2i/JzcLzbpXFb2Gw3R+mUch0LK1R7ubup/kQdhJJdf/u/IDO6LSL9AW2fm6YPsMzdABdA33JfGp1d" +
            "DJYbqkW5ELyeHrdOAa4vibv3O8dFyYpPeTI0p9Z5lL6TD+xP0rG5e4LgTsVw94aeZBqb3TVoA4Y83CZogxoWYubLieVSdM" +
            "9uxxtKqkyEwRGTTRAwbdV3pInrlyHZevvHvcjdIjA06rxMlvL9zfIHhDfyc54luNuJX31+jodioqvXX+OwAuMcA0I7/iGQ" +
            "CQuoaFOMCcEHYRhwZTqu5/iIoO7J6TmCXw38qW3wiQ/p5VsxxAgMBAAECggEAA+8Te+P2U+ohIkkkI7bpQm6pEiK8JhDGb" +
            "04armAKa45iOe+Ywu0z8SYS+5hyr9Czoj6O/s2cBGNymoXc1b2ngXZKA1GKKJazuoxg+u+uMmHhak8wGO4Iw4UkNBpXxAw" +
            "2mhxxzspfY+hy+yxoQiag7PW3EH3Db9y4w+8pAShtBvVXqQRqeDbSadhhpnhpekd/NGcDWlZP+Sce3lNbDslMdKCx2ucdO" +
            "lqfjDo6EsRknqvXS0rpVQyeYFG4iv5i60p1a5YCntXJQgkZgsZME1jb8j6c65x+Hc8/1EkuutRH8T8jdJc3iqcM4rwz983" +
            "1XB0LwktCv8FzWGq+O+ouoELFwQKBgQD54dqHgjvmIQqjKvc634IwMASyKTUg7TZ2YLvcpzzjM26VkBMj3s95yqMVjFMTv" +
            "rQu5NbBmiAr2zjnqYXd40W91BjJhC/RyWLR1Nvpf/gefojzhjLO6S1PQUAJ6hQzgzJejnG8OaiDLnCfrxBm9uk9wPHdyUd" +
            "KCwws1k2uy1aHmQKBgQDTz22XCSjrQi0NxzIMYL2sL9hAdOKKbbSxZLAu80w60ECG2F/xELgHS6Qv9qmU40CbJXZY+rEZm" +
            "bzxTcaeuFDS/x8umUObXv2SJQkYfu9XotE+2RQWaeKNpQd56ZQsusthZ1VVZxCn8qZ5QcHDzNnFIQe3W6+Ci3sb1qeOuC8" +
            "SmQKBgCeS0DQDuQ7CDtg2dr75JLoS8LtycTqMtsJaoYXZangk7g97qLxWjg8gu2EvPvzyh8Chdy1kBlJLvqBZpZy1YJcmn" +
            "uJTL+uOdDr89fLt1FKoAXJnv2YrYYSatdScIKTj0zdMYdDIZNqZoTZ42CUmV1vzUZqpRMQCKeRz8AuNol+JAoGBAKvU2JQ" +
            "yEycgLYrC8eBGzzkUK3zHFk21CGTtSV0dddc0wVRjzxmzNYh9nfpnQlYOMohq0OMIpYoeRcEBFsQGxVMXM4XLQqSWYGIid" +
            "4mO2L6g0N4Kn5g7WFcO7czCaLoM5BfmC71X+pQ1b0ZpyTb+RiD9VdQzpmPiogIIlzBaTZ3pAoGAK9eRtXRE0no6T2hH/6l" +
            "0U0j9b9PsIQc7ufliGFDiM1cLQreeLYeRVPe2HkUeym9zaZiLRME16rvBYc0As+0OeSi2pIsm9pkqQ4xzKpx1dDqltY2o6" +
            "+axwmA5nesaYRzH2bOC47XGfWe6F0wnI/ZkpcAZ2mXawKREsQW9d/+xtF0=";

    /**
     * 公钥
     */
    public static final String PUBLIC_KEY = "MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAzr+ftfseJxl3XDuf" +
            "RwqrfWrbAWWtovyc3C826VxW9hsN0fplHIdCytUe7m7qf5EHYSSXX/7vyAzui0i/QFtn5umD7DM3QAXQN9yXxqdXQyWG6p" +
            "FuRC8nh63TgGuL4m79zvHRcmKT3kyNKfWeZS+kw/sT9KxuXuC4E7FcPeGnmQam901aAOGPNwmaIMaFmLmy4nlUnTPbscbS" +
            "qpMhMERk00QMG3Vd6SJ65ch2Xr7x73I3SIwNOq8TJby/c3yB4Q38nOeJbjbiV99fo6HYqKr11/jsALjHANCO/4hkAkLqGhT" +
            "jAnBB2EYcGU6ruf4iKDuyek5gl8N/Klt8IkP6eVbMcQIDAQAB";



    /**
     * 私钥解密
     *
     * @param privateKeyString 私钥
     * @param text             待解密的文本
     * @return 解密后的文本
     */
    public static String decryptByPrivateKey(String privateKeyString, String text) throws Exception {
        if(StringUtils.isAnyEmpty(privateKeyString))
            privateKeyString = PRIVATE_KEY;
        PKCS8EncodedKeySpec pkcs8EncodedKeySpec5 = new PKCS8EncodedKeySpec(Base64.decodeBase64(privateKeyString));
        KeyFactory keyFactory = KeyFactory.getInstance("RSA");
        PrivateKey privateKey = keyFactory.generatePrivate(pkcs8EncodedKeySpec5);
        Cipher cipher = Cipher.getInstance("RSA");
        cipher.init(Cipher.DECRYPT_MODE, privateKey);
        byte[] result = cipher.doFinal(Base64.decodeBase64(text));
        return new String(result);
    }

    /**
     * 公钥加密
     * @param plainText
     * @param publicKeyString
     * @return
     * @throws Exception
     */
    public static String encryptByPublicKey(String publicKeyString ,String plainText) throws Exception {
        if (StringUtils.isEmpty(publicKeyString)) {
            publicKeyString = PUBLIC_KEY;
        }
        Cipher cipher = Cipher.getInstance("RSA");
        X509EncodedKeySpec x509EncodedKeySpec = new X509EncodedKeySpec(Base64.decodeBase64(publicKeyString));
        KeyFactory keyFactory = KeyFactory.getInstance("RSA");
        PublicKey publicKey = keyFactory.generatePublic(x509EncodedKeySpec);
        cipher.init(Cipher.ENCRYPT_MODE, publicKey);
        byte[] encryptedBytes = cipher.doFinal(plainText.getBytes());
        // 使用Base64编码字节数组
        return Base64.encodeBase64String(encryptedBytes);
    }


}
